/* Sistemas Integrados TECNISA
   Gesto de Projetos

Nome: 8801_GEPSTPO.sql

Descrio:
Insero da descrio de uma evoluo de requisito no momento da incluso da
mesma a partir da descrio da evoluo ativa do requisito.
Utilizada na alterao de um requisito existente.

Criao:
10/10/2003 Leonardo Leo de Assis
*/

CREATE OR REPLACE PROCEDURE INSERE_DESCREQPROD_ALTERACAO
  (P_CDPRODGRUP       IN VARCHAR2,
   P_CDREQPROD        IN VARCHAR2,
   P_NRSEQREQPROD     IN VARCHAR2) IS

BEGIN

   INSERT INTO DESCREQPROD
      (CDPRODGRUP,
       CDREQPROD,
       NRSEQREQPROD,
       NRDSREQPROD)
   (SELECT
       P_CDPRODGRUP,
       P_CDREQPROD,
       P_NRSEQREQPROD,
       DES.NRDSREQPROD
    FROM
       DESCREQPROD DES,
       EVOLREQPROD EVO
    WHERE
      DES.CDPRODGRUP   = P_CDPRODGRUP     AND
      DES.CDREQPROD    = P_CDREQPROD      AND
      EVO.CDPRODGRUP   = DES.CDPRODGRUP   AND
      EVO.CDREQPROD    = DES.CDREQPROD    AND
      EVO.NRSEQREQPROD = DES.NRSEQREQPROD AND
      EVO.IDSTEVORPROD = 'A');

   FOR CURS IN
      (SELECT
          DES.NRDSREQPROD,
          DES.TXREQPROD
       FROM
          DESCREQPROD DES,
          EVOLREQPROD EVO
       WHERE
         DES.CDPRODGRUP   = P_CDPRODGRUP     AND
         DES.CDREQPROD    = P_CDREQPROD      AND
         EVO.CDPRODGRUP   = DES.CDPRODGRUP   AND
         EVO.CDREQPROD    = DES.CDREQPROD    AND
         EVO.NRSEQREQPROD = DES.NRSEQREQPROD AND
         EVO.IDSTEVORPROD = 'A') LOOP
      UPDATE DESCREQPROD SET TXREQPROD = CURS.TXREQPROD
      WHERE
         CDPRODGRUP   = P_CDPRODGRUP   AND
         CDREQPROD    = P_CDREQPROD    AND
         NRSEQREQPROD = P_NRSEQREQPROD AND
         NRDSREQPROD  = CURS.NRDSREQPROD;
   END LOOP;
END;
/
