<?php
namespace Teknisa\Model\Gestaopessoas\Entities;

use HCM\FPA\Entity\FpaVinceventoEntity;

class FpaVincevento extends \Teknisa\Model\Gestaopessoas\Entities\Base\FpaVincevento {
    
    public function determinaReferencia(){

        switch($this->getIdrefgerar()){
        case FpaVinceventoEntity::IDREFGERAR_PERCENTUAL:
            $referencia = $this->getVrpercent();
            break;

        case FpaVinceventoEntity::IDREFGERAR_MULTIPLICADOR:
            $referencia = $this->getVrmultiplic();
            break;

        case FpaVinceventoEntity::IDREFGERAR_DIVISOR:
            $referencia = $this->getVrdivide();
            break;

        case FpaVinceventoEntity::IDREFGERAR_NENHUM:
            $referencia = $this->getVrreffixo();
            break;
        }
        return $referencia;
    }
    
    public function calculaValor($valor){
        $percentual = $this->getVrpercent();
        if ($percentual !== 100 && empty($percentual) === false) {
            $valor = ($valor * $percentual) / 100;
        }

        $multiplicador = $this->getVrmultiplic();
        if ($multiplicador !== 1 && empty($multiplicador) === false) {
            $valor = $valor * $multiplicador;
        }

        $divisor = $this->getVrdivide();
        if ($divisor !== 1 && empty($divisor) === false) {
            $valor = $valor / $divisor;
        }

        return $valor;
    }
    
    public function __clone() {
        $this->setNrvincevento(\HCM\Util\NovoCodigo::geraCodigo($this->getNrorg(), 'FPA_VINCEVENTO', 1, 12, true));
    }

    
}