var Est92000_ConsultaInventarioCego_Controller = function(templateManager, ScreenService, MessageService, General, Colors, EstUtil, ZHPromise, ZhFilterPreferences, localStorageEngine, Est92000_ConsultaInventarioCego_Services) {

    //Inventory Widget Functions

    this.onOpenFilter = function(widget) {
        let rowsToSet = {};
        Est92000_ConsultaInventarioCego_Services.getFilialLogada().then(success => {
            const dtInicial = getLocalVar('DTPROCESSA');
            const dtFinal = moment().endOf('month').format('DD/MM/YYYY');

            rowsToSet.DTCONTAGEM = { "start": dtInicial, "end": dtFinal, "formattedStart": dtInicial, "formattedEnd": dtFinal };
            rowsToSet.NMFILIAL = [success.dataset.filial[0].NMFILIAL];
            rowsToSet.CDFILIAL = [success.dataset.filial[0].CDFILIAL];

            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(success => {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').fields.map(field => {
                    if (field.name === "NMFILIAL" || field.name === "DTCONTAGEM") field.reload();
                });
            });
        });
    };

    this.setFilterParams = function(widget, preference = null) {
        let filtro = [];
        const filterRow = preference.FILTER_ROW;

        filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": EstUtil.getFieldValue('CDFILIAL', 'inventoryGrid', true)
            },
            {
                "name": "DTINICIAL",
                "operator": "=",
                "value": filterRow.DTCONTAGEM ? filterRow.DTCONTAGEM.start : null
            },
            {
                "name": "DTFINAL",
                "operator": "=",
                "value": filterRow.DTCONTAGEM ? filterRow.DTCONTAGEM.end : null
            },
            {
                "name": "IDSITESTCEGO",
                "operator": "=",
                "value": "T"
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar("CDOPERADOR")
            }
        ];

        widget.dataSourceFilter = filtro;
        widget.reload();
    };

    this.onOpenSwipe = function(widget) {
        const productsWidget = templateManager.container.getWidget('productsGrid');

        const fieldsVisibilitHandler = (field, WidgetName) => {
            return widget.currentRow.IDUTILLOTE == "S" ? General.setVisibleField(field, WidgetName) : General.setInvisibleField(field, WidgetName);
        };

        ["NRLOTEESTQ", "NRSUBLOTE"].map(field => fieldsVisibilitHandler(field, productsWidget.name));

        ScreenService.openSwipe(productsWidget).then(() => {
            productsWidget.reload();
        });
    };

    //Reports products Functions

    this.openPopupReport = function(args) {
        const widgetPopup = templateManager.container.getWidget('popupReport');
        ScreenService.openPopup(widgetPopup).then(()=>{
            widgetPopup.getField('REPORT_TYPE').value('CIC'); // "defaultValue" JSON wasn't working 
        });
        
    };

    this.openGridReport = function(widget) {
        const inventoryWidget = templateManager.container.getWidget("inventoryGrid");
        const checkedRows = inventoryWidget.getCheckedRows();

        if (checkedRows.length === 0) return MessageService.showMessageByCode('EMPTY_DATA');

        ScreenService.openWindow("est_estoqueCego#est92000_grid_relatorios").then(() => {
            const widgetGrid = templateManager.containers["est_estoqueCego#est92000_grid_relatorios"].getWidget('gridReport');
            const reportType = widget.currentRow.REPORT_TYPE;

            if (widgetGrid) {
                widgetGrid.dataSourceFilter = [
                    {
                        "name": "DATA",
                        "operator": "=",
                        "value": checkedRows
                    },
                    {
                        "name": "REPORT_TYPE",
                        "operator": "=",
                        "value": reportType
	                }
	        	];
                this.reportFormatLayout(reportType, widgetGrid);
            }
            else {
                MessageService.showMessageByCode('GENERATION_REPORT_ERROR');
            }
        });
    };

    //Support Functions
    this.grayColorHandler = function(row) {
        return Est92000_ConsultaInventarioCego_Services.getDate(row.DTCONTAGEM) < Est92000_ConsultaInventarioCego_Services.getDate ? true : false;
    };

    this.reportFormatLayout = function(reportType, widgetGrid) {
        if (reportType === 'LIC') {
            widgetGrid.label = 'Listagem Inventário Cego';

            widgetGrid.getField("QTINVENTESTCEGO").isVisible = false;
            widgetGrid.getField("QTINVENTESTCEGO_LIC").isVisible = true;

        }
        else {
            widgetGrid.label = 'Consulta do Inventário Cego';

            widgetGrid.getField("QTINVENTESTCEGO").isVisible = true;
            widgetGrid.getField("QTINVENTESTCEGO_LIC").isVisible = false;

        }
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('Est92000_ConsultaInventarioCego_Controller', Est92000_ConsultaInventarioCego_Controller);
});
