package com.javaseleniumtemplate.tests;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.RetiradaDeEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.RetiradaDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class RetiradaDeEstoqueTests extends TestBase{
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    RetiradaDeEstoqueFlows retiradaDeEstoqueFlows;
    RetiradaDeEstoquePage retiradaDeEstoquePage;


    @Test (description = "Est-19")
    public void EfetuarRetiradaDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueFlows = new RetiradaDeEstoqueFlows();
        retiradaDeEstoquePage = new RetiradaDeEstoquePage();


        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado Retirada de Estoque";
        String descProduto = "SUMO DE LIMAO - CX12 500ML";
        String descAlmoxarifado = "HELA MATRIZ";
        String campoSetor = "Administrativo";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String valorDevolvido = "1";
        String campoRetirada = "CONSUMO DE PRODUÇÃO";
        String quantidadeBanco = "18";
        String quantidadeSolicitada = "3";
        String quantidadeDevolvida = "1";
        String quantidadeRestante = "2";
        String valorUnitarioLancado = "1.2";






        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        retiradaDeEstoqueFlows.AdicionarRetiradaEstoque(cmpDesc,descProduto,quantidade,descAlmoxarifado,DescCampoLote,valorDevolvido, campoSetor, campoRetirada);


        //Banco tela de retirada
       String numeroLancamento = retiradaDeEstoquePage.retornaNumeroLancamento();
       Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(quantidadeBanco));

        String valorSolicitado = retiradaDeEstoquePage.retornaQuantidadeSolicitada();
        Assert.assertTrue(DBSteps.retornaQuantidadeSolicitadaEstoque(valorSolicitado).contains(quantidadeSolicitada));

        String devolucaoEstoque = retiradaDeEstoquePage.retornaQuantidadeDevolvida();
         Assert.assertTrue(DBSteps.retornaQuantidadeDevolvidaEstoque(devolucaoEstoque).contains(quantidadeDevolvida));

       String restanteEstoque = retiradaDeEstoquePage.retornaQuantidadeRestante();
        Assert.assertTrue(DBSteps.retornaQuantidadeRestanteEstoque(restanteEstoque).contains(quantidadeRestante));

        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));




    }
    @Test(description = "Est-20")
    public void EditarRetiradaEstoque(){
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueFlows = new RetiradaDeEstoqueFlows();
        retiradaDeEstoquePage = new RetiradaDeEstoquePage();

        //Parametres
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String campoEditado ="Deletar";

        //Rotine:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        retiradaDeEstoqueFlows.EditarRetiradaEstoque(campoEditado);

    }
    @Test(description = "Est-21")
    public void ExcluirRetiradaEstoque(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueFlows = new RetiradaDeEstoqueFlows();
        retiradaDeEstoquePage = new RetiradaDeEstoquePage();

        //Parametres
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";


        //rotine
        loginFlows.efetuarLogin();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        retiradaDeEstoqueFlows.ExcluirRetiradaEstoque();

    }

@Test(description = "Est-00")
@Ignore
    public void TesteBanco() {

    mainPage = new MainPage();
    loginFlows = new LoginFlows();
    mainFlows = new MainFlows();
    retiradaDeEstoqueFlows = new RetiradaDeEstoqueFlows();
    retiradaDeEstoquePage = new RetiradaDeEstoquePage();


    //Rotinas:
    // loginFlows.efetuarLogin();
    String ntlancestq = "0000007209";
    String teste = DBSteps.retornaQuantidadeRestanteEstoque(ntlancestq);
    System.out.println(teste);


}
}